// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package auth_web

import (
	context "context"
	empty "github.com/golang/protobuf/ptypes/empty"
	auth_common "gitlab.com/adhocguru/fcp/apis/gen/accounting/v1/auth_common"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// WebAuthServiceClient is the client API for WebAuthService service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type WebAuthServiceClient interface {
	GetUser(ctx context.Context, in *GetUserRequest, opts ...grpc.CallOption) (*auth_common.UserBriefInfo, error)
	UpdateUser(ctx context.Context, in *UpdateUserRequest, opts ...grpc.CallOption) (*auth_common.UserBriefInfo, error)
	CheckPassword(ctx context.Context, in *CheckPasswordRequest, opts ...grpc.CallOption) (*CheckPasswordResponse, error)
	InitPasswordReset(ctx context.Context, in *InitPasswordResetRequest, opts ...grpc.CallOption) (*InitPasswordResetResponse, error)
	ValidatePasswordResetToken(ctx context.Context, in *ValidatePasswordResetTokenRequest, opts ...grpc.CallOption) (*ValidatePasswordResetTokenResponse, error)
	ResetPassword(ctx context.Context, in *ResetPasswordRequest, opts ...grpc.CallOption) (*ResetPasswordResponse, error)
	GetUserResetToken(ctx context.Context, in *GetUserResetTokenRequest, opts ...grpc.CallOption) (*GetUserResetTokenResponse, error)
	Login(ctx context.Context, in *LoginRequest, opts ...grpc.CallOption) (*LoginResponse, error)
	Logout(ctx context.Context, in *LogoutRequest, opts ...grpc.CallOption) (*empty.Empty, error)
	ValidateSession(ctx context.Context, in *ValidateSessionRequest, opts ...grpc.CallOption) (*ValidateSessionResponse, error)
	ChangePassword(ctx context.Context, in *ChangePasswordRequest, opts ...grpc.CallOption) (*empty.Empty, error)
}

type webAuthServiceClient struct {
	cc grpc.ClientConnInterface
}

func NewWebAuthServiceClient(cc grpc.ClientConnInterface) WebAuthServiceClient {
	return &webAuthServiceClient{cc}
}

func (c *webAuthServiceClient) GetUser(ctx context.Context, in *GetUserRequest, opts ...grpc.CallOption) (*auth_common.UserBriefInfo, error) {
	out := new(auth_common.UserBriefInfo)
	err := c.cc.Invoke(ctx, "/fcp.accounting.v1.auth_web.WebAuthService/GetUser", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *webAuthServiceClient) UpdateUser(ctx context.Context, in *UpdateUserRequest, opts ...grpc.CallOption) (*auth_common.UserBriefInfo, error) {
	out := new(auth_common.UserBriefInfo)
	err := c.cc.Invoke(ctx, "/fcp.accounting.v1.auth_web.WebAuthService/UpdateUser", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *webAuthServiceClient) CheckPassword(ctx context.Context, in *CheckPasswordRequest, opts ...grpc.CallOption) (*CheckPasswordResponse, error) {
	out := new(CheckPasswordResponse)
	err := c.cc.Invoke(ctx, "/fcp.accounting.v1.auth_web.WebAuthService/CheckPassword", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *webAuthServiceClient) InitPasswordReset(ctx context.Context, in *InitPasswordResetRequest, opts ...grpc.CallOption) (*InitPasswordResetResponse, error) {
	out := new(InitPasswordResetResponse)
	err := c.cc.Invoke(ctx, "/fcp.accounting.v1.auth_web.WebAuthService/InitPasswordReset", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *webAuthServiceClient) ValidatePasswordResetToken(ctx context.Context, in *ValidatePasswordResetTokenRequest, opts ...grpc.CallOption) (*ValidatePasswordResetTokenResponse, error) {
	out := new(ValidatePasswordResetTokenResponse)
	err := c.cc.Invoke(ctx, "/fcp.accounting.v1.auth_web.WebAuthService/ValidatePasswordResetToken", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *webAuthServiceClient) ResetPassword(ctx context.Context, in *ResetPasswordRequest, opts ...grpc.CallOption) (*ResetPasswordResponse, error) {
	out := new(ResetPasswordResponse)
	err := c.cc.Invoke(ctx, "/fcp.accounting.v1.auth_web.WebAuthService/ResetPassword", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *webAuthServiceClient) GetUserResetToken(ctx context.Context, in *GetUserResetTokenRequest, opts ...grpc.CallOption) (*GetUserResetTokenResponse, error) {
	out := new(GetUserResetTokenResponse)
	err := c.cc.Invoke(ctx, "/fcp.accounting.v1.auth_web.WebAuthService/GetUserResetToken", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *webAuthServiceClient) Login(ctx context.Context, in *LoginRequest, opts ...grpc.CallOption) (*LoginResponse, error) {
	out := new(LoginResponse)
	err := c.cc.Invoke(ctx, "/fcp.accounting.v1.auth_web.WebAuthService/Login", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *webAuthServiceClient) Logout(ctx context.Context, in *LogoutRequest, opts ...grpc.CallOption) (*empty.Empty, error) {
	out := new(empty.Empty)
	err := c.cc.Invoke(ctx, "/fcp.accounting.v1.auth_web.WebAuthService/Logout", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *webAuthServiceClient) ValidateSession(ctx context.Context, in *ValidateSessionRequest, opts ...grpc.CallOption) (*ValidateSessionResponse, error) {
	out := new(ValidateSessionResponse)
	err := c.cc.Invoke(ctx, "/fcp.accounting.v1.auth_web.WebAuthService/ValidateSession", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *webAuthServiceClient) ChangePassword(ctx context.Context, in *ChangePasswordRequest, opts ...grpc.CallOption) (*empty.Empty, error) {
	out := new(empty.Empty)
	err := c.cc.Invoke(ctx, "/fcp.accounting.v1.auth_web.WebAuthService/ChangePassword", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// WebAuthServiceServer is the server API for WebAuthService service.
// All implementations must embed UnimplementedWebAuthServiceServer
// for forward compatibility
type WebAuthServiceServer interface {
	GetUser(context.Context, *GetUserRequest) (*auth_common.UserBriefInfo, error)
	UpdateUser(context.Context, *UpdateUserRequest) (*auth_common.UserBriefInfo, error)
	CheckPassword(context.Context, *CheckPasswordRequest) (*CheckPasswordResponse, error)
	InitPasswordReset(context.Context, *InitPasswordResetRequest) (*InitPasswordResetResponse, error)
	ValidatePasswordResetToken(context.Context, *ValidatePasswordResetTokenRequest) (*ValidatePasswordResetTokenResponse, error)
	ResetPassword(context.Context, *ResetPasswordRequest) (*ResetPasswordResponse, error)
	GetUserResetToken(context.Context, *GetUserResetTokenRequest) (*GetUserResetTokenResponse, error)
	Login(context.Context, *LoginRequest) (*LoginResponse, error)
	Logout(context.Context, *LogoutRequest) (*empty.Empty, error)
	ValidateSession(context.Context, *ValidateSessionRequest) (*ValidateSessionResponse, error)
	ChangePassword(context.Context, *ChangePasswordRequest) (*empty.Empty, error)
	mustEmbedUnimplementedWebAuthServiceServer()
}

// UnimplementedWebAuthServiceServer must be embedded to have forward compatible implementations.
type UnimplementedWebAuthServiceServer struct {
}

func (UnimplementedWebAuthServiceServer) GetUser(context.Context, *GetUserRequest) (*auth_common.UserBriefInfo, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetUser not implemented")
}
func (UnimplementedWebAuthServiceServer) UpdateUser(context.Context, *UpdateUserRequest) (*auth_common.UserBriefInfo, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UpdateUser not implemented")
}
func (UnimplementedWebAuthServiceServer) CheckPassword(context.Context, *CheckPasswordRequest) (*CheckPasswordResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CheckPassword not implemented")
}
func (UnimplementedWebAuthServiceServer) InitPasswordReset(context.Context, *InitPasswordResetRequest) (*InitPasswordResetResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method InitPasswordReset not implemented")
}
func (UnimplementedWebAuthServiceServer) ValidatePasswordResetToken(context.Context, *ValidatePasswordResetTokenRequest) (*ValidatePasswordResetTokenResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ValidatePasswordResetToken not implemented")
}
func (UnimplementedWebAuthServiceServer) ResetPassword(context.Context, *ResetPasswordRequest) (*ResetPasswordResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ResetPassword not implemented")
}
func (UnimplementedWebAuthServiceServer) GetUserResetToken(context.Context, *GetUserResetTokenRequest) (*GetUserResetTokenResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetUserResetToken not implemented")
}
func (UnimplementedWebAuthServiceServer) Login(context.Context, *LoginRequest) (*LoginResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Login not implemented")
}
func (UnimplementedWebAuthServiceServer) Logout(context.Context, *LogoutRequest) (*empty.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Logout not implemented")
}
func (UnimplementedWebAuthServiceServer) ValidateSession(context.Context, *ValidateSessionRequest) (*ValidateSessionResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ValidateSession not implemented")
}
func (UnimplementedWebAuthServiceServer) ChangePassword(context.Context, *ChangePasswordRequest) (*empty.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ChangePassword not implemented")
}
func (UnimplementedWebAuthServiceServer) mustEmbedUnimplementedWebAuthServiceServer() {}

// UnsafeWebAuthServiceServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to WebAuthServiceServer will
// result in compilation errors.
type UnsafeWebAuthServiceServer interface {
	mustEmbedUnimplementedWebAuthServiceServer()
}

func RegisterWebAuthServiceServer(s grpc.ServiceRegistrar, srv WebAuthServiceServer) {
	s.RegisterService(&WebAuthService_ServiceDesc, srv)
}

func _WebAuthService_GetUser_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetUserRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(WebAuthServiceServer).GetUser(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/fcp.accounting.v1.auth_web.WebAuthService/GetUser",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(WebAuthServiceServer).GetUser(ctx, req.(*GetUserRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _WebAuthService_UpdateUser_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(UpdateUserRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(WebAuthServiceServer).UpdateUser(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/fcp.accounting.v1.auth_web.WebAuthService/UpdateUser",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(WebAuthServiceServer).UpdateUser(ctx, req.(*UpdateUserRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _WebAuthService_CheckPassword_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CheckPasswordRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(WebAuthServiceServer).CheckPassword(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/fcp.accounting.v1.auth_web.WebAuthService/CheckPassword",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(WebAuthServiceServer).CheckPassword(ctx, req.(*CheckPasswordRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _WebAuthService_InitPasswordReset_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(InitPasswordResetRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(WebAuthServiceServer).InitPasswordReset(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/fcp.accounting.v1.auth_web.WebAuthService/InitPasswordReset",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(WebAuthServiceServer).InitPasswordReset(ctx, req.(*InitPasswordResetRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _WebAuthService_ValidatePasswordResetToken_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ValidatePasswordResetTokenRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(WebAuthServiceServer).ValidatePasswordResetToken(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/fcp.accounting.v1.auth_web.WebAuthService/ValidatePasswordResetToken",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(WebAuthServiceServer).ValidatePasswordResetToken(ctx, req.(*ValidatePasswordResetTokenRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _WebAuthService_ResetPassword_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ResetPasswordRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(WebAuthServiceServer).ResetPassword(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/fcp.accounting.v1.auth_web.WebAuthService/ResetPassword",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(WebAuthServiceServer).ResetPassword(ctx, req.(*ResetPasswordRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _WebAuthService_GetUserResetToken_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetUserResetTokenRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(WebAuthServiceServer).GetUserResetToken(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/fcp.accounting.v1.auth_web.WebAuthService/GetUserResetToken",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(WebAuthServiceServer).GetUserResetToken(ctx, req.(*GetUserResetTokenRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _WebAuthService_Login_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(LoginRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(WebAuthServiceServer).Login(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/fcp.accounting.v1.auth_web.WebAuthService/Login",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(WebAuthServiceServer).Login(ctx, req.(*LoginRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _WebAuthService_Logout_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(LogoutRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(WebAuthServiceServer).Logout(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/fcp.accounting.v1.auth_web.WebAuthService/Logout",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(WebAuthServiceServer).Logout(ctx, req.(*LogoutRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _WebAuthService_ValidateSession_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ValidateSessionRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(WebAuthServiceServer).ValidateSession(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/fcp.accounting.v1.auth_web.WebAuthService/ValidateSession",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(WebAuthServiceServer).ValidateSession(ctx, req.(*ValidateSessionRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _WebAuthService_ChangePassword_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ChangePasswordRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(WebAuthServiceServer).ChangePassword(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/fcp.accounting.v1.auth_web.WebAuthService/ChangePassword",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(WebAuthServiceServer).ChangePassword(ctx, req.(*ChangePasswordRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// WebAuthService_ServiceDesc is the grpc.ServiceDesc for WebAuthService service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var WebAuthService_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "fcp.accounting.v1.auth_web.WebAuthService",
	HandlerType: (*WebAuthServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "GetUser",
			Handler:    _WebAuthService_GetUser_Handler,
		},
		{
			MethodName: "UpdateUser",
			Handler:    _WebAuthService_UpdateUser_Handler,
		},
		{
			MethodName: "CheckPassword",
			Handler:    _WebAuthService_CheckPassword_Handler,
		},
		{
			MethodName: "InitPasswordReset",
			Handler:    _WebAuthService_InitPasswordReset_Handler,
		},
		{
			MethodName: "ValidatePasswordResetToken",
			Handler:    _WebAuthService_ValidatePasswordResetToken_Handler,
		},
		{
			MethodName: "ResetPassword",
			Handler:    _WebAuthService_ResetPassword_Handler,
		},
		{
			MethodName: "GetUserResetToken",
			Handler:    _WebAuthService_GetUserResetToken_Handler,
		},
		{
			MethodName: "Login",
			Handler:    _WebAuthService_Login_Handler,
		},
		{
			MethodName: "Logout",
			Handler:    _WebAuthService_Logout_Handler,
		},
		{
			MethodName: "ValidateSession",
			Handler:    _WebAuthService_ValidateSession_Handler,
		},
		{
			MethodName: "ChangePassword",
			Handler:    _WebAuthService_ChangePassword_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "v1/auth_web/auth_service.proto",
}
